#include "../include/Test.h"

Test::Test( bool verbose = true ){
  this->verbose = verbose ;
}

bool Test::print_assertEqual( std::string result, std::string expected )
{
  if (Test::do_assertEqual( result, expected )){
    std::cout << "[\033[32msuccess\033[0m] : result equals expectation : \033[36m" << result << "\033[0m" << std::endl ;
    return true;
  }else{
    std::cout << "[\033[31mfailure\033[0m] : result \033[36m: " << result << "\033[0m" << " ≠ \033[36m" << expected << std::endl;
    return false;
  }
}

bool Test::do_assertEqual( std::string result, std::string expected )
{
  return ( result == expected );
}

bool Test::assertEqual( std::string result, std::string expected )
{
  return ( this->verbose )?
    Test::print_assertEqual( result, expected ):
    Test::do_assertEqual( result, expected );
}

bool Test::print_assertNotEqual( std::string result, std::string expected )
{
  if ( Test::do_assertNotEqual( result, expected ) ){
    std::cout << "[\033[31mfailure\033[0m] : result equals expectation : \033[36m" << result << "\033[0m" << std::endl;
    return true;
  }else{
    std::cout << "[\033[32msuccess\033[0m] : \033[36m" << result << "\033[0m" << " ≠ \033[36m" << expected << "\033[0m" << std::endl;
    return false;
  }
}

bool Test::do_assertNotEqual( std::string result, std::string expected )
{
  return !Test::assertEqual( result, expected );
}

bool Test::assertNotEqual( std::string result, std::string expected )
{
  return ( this->verbose )?
    Test::print_assertNotEqual( result, expected ):
    Test::do_assertNotEqual( result, expected );
}

bool Test::assertInRange( int value, int min, int max ){
  return (this->verbose)?
    Test::print_assertInRange( value, min, max ) :
    Test::do_assertInRange( value, min, max ) ;
}

bool Test::do_assertInRange( int value, int min, int max ){
  return ( value < min || value > max )?
    false :
    true ;
}

bool Test::print_assertInRange( int value, int min, int max ){
  if( Test::do_assertInRange( value, min, max ) ){
    std::cout << "[\033[32msuccess\033[0m] : \033[36m" << value << "\033[0m" << " in \033[36m[" << min << ";" << max << "]\033[0m" << std::endl ;
    return true;
  }else{
    std::cout << "[\033[31mfailure\033[0m] : \033[36m" << value << "\033[0m" << " not in \033[36m[" << min << ";" << max << "]\033[0m" << std::endl ;
    return false;
  }
}

bool Test::assertNotInRange( int value, int min, int max ){
  return (this->verbose)?
    Test::print_assertNotInRange( value, min, max ) :
    Test::do_assertNotInRange( value, min, max ) ;
}

bool Test::do_assertNotInRange( int value, int min, int max ){
  return ( value < min || value > max )?
    true :
    false ;
}

bool Test::print_assertNotInRange( int value, int min, int max ){
  if( Test::do_assertNotInRange( value, min, max ) ){
    std::cout << "[\033[32msuccess\033[0m] : value : \033[36m" << value << "\033[0m" << std::endl
	      << "            range : \033[36m[" << min << ";" << max << "]\033[0m" << std::endl;
    return true;
  }else{
    std::cout << "[\033[31mfailure\033[0m] : value in range : \033[36m" << value << "\033[0m" << std::endl
	      << "            range : \033[36m[" << min << ";" << max << "]\033[0m" << std::endl;
    return false;
  }
}
